diff --git a/src/backend/commands/tablecmds.c b/src/backend/commands/tablecmds.c
index f976c0e5c7e..4abba13a5b8 100644
--- a/src/backend/commands/tablecmds.c
+++ b/src/backend/commands/tablecmds.c
@@ -17398,7 +16229,7 @@ ATExecAddInherit(Relation child_rel, RangeVar *parent, LOCKMODE lockmode)
  *
  * Common to ATExecAddInherit() and ATExecAttachPartition().
  */
-static void
+void
 CreateInheritance(Relation child_rel, Relation parent_rel, bool ispartition)
 {
 	Relation	catalogRelation;
@@ -17884,78 +16715,6 @@ ATExecDropInherit(Relation rel, RangeVar *parent, LOCKMODE lockmode)
 	return address;
 }
 
-/*
- * MarkInheritDetached
- *
- * Set inhdetachpending for a partition, for ATExecDetachPartition
- * in concurrent mode.  While at it, verify that no other partition is
- * already pending detach.
- */
-static void
-MarkInheritDetached(Relation child_rel, Relation parent_rel)
-{
-	Relation	catalogRelation;
-	SysScanDesc scan;
-	ScanKeyData key;
-	HeapTuple	inheritsTuple;
-	bool		found = false;
-
-	Assert(parent_rel->rd_rel->relkind == RELKIND_PARTITIONED_TABLE);
-
-	/*
-	 * Find pg_inherits entries by inhparent.  (We need to scan them all in
-	 * order to verify that no other partition is pending detach.)
-	 */
-	catalogRelation = table_open(InheritsRelationId, RowExclusiveLock);
-	ScanKeyInit(&key,
-				Anum_pg_inherits_inhparent,
-				BTEqualStrategyNumber, F_OIDEQ,
-				ObjectIdGetDatum(RelationGetRelid(parent_rel)));
-	scan = systable_beginscan(catalogRelation, InheritsParentIndexId,
-							  true, NULL, 1, &key);
-
-	while (HeapTupleIsValid(inheritsTuple = systable_getnext(scan)))
-	{
-		Form_pg_inherits inhForm;
-
-		inhForm = (Form_pg_inherits) GETSTRUCT(inheritsTuple);
-		if (inhForm->inhdetachpending)
-			ereport(ERROR,
-					errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
-					errmsg("partition \"%s\" already pending detach in partitioned table \"%s.%s\"",
-						   get_rel_name(inhForm->inhrelid),
-						   get_namespace_name(parent_rel->rd_rel->relnamespace),
-						   RelationGetRelationName(parent_rel)),
-					errhint("Use ALTER TABLE ... DETACH PARTITION ... FINALIZE to complete the pending detach operation."));
-
-		if (inhForm->inhrelid == RelationGetRelid(child_rel))
-		{
-			HeapTuple	newtup;
-
-			newtup = heap_copytuple(inheritsTuple);
-			((Form_pg_inherits) GETSTRUCT(newtup))->inhdetachpending = true;
-
-			CatalogTupleUpdate(catalogRelation,
-							   &inheritsTuple->t_self,
-							   newtup);
-			found = true;
-			heap_freetuple(newtup);
-			/* keep looking, to ensure we catch others pending detach */
-		}
-	}
-
-	/* Done */
-	systable_endscan(scan);
-	table_close(catalogRelation, RowExclusiveLock);
-
-	if (!found)
-		ereport(ERROR,
-				(errcode(ERRCODE_UNDEFINED_TABLE),
-				 errmsg("relation \"%s\" is not a partition of relation \"%s\"",
-						RelationGetRelationName(child_rel),
-						RelationGetRelationName(parent_rel))));
-}
-
 /*
  * RemoveInheritance
  *
@@ -17974,7 +16733,7 @@ MarkInheritDetached(Relation child_rel, Relation parent_rel)
  *
  * Common to ATExecDropInherit() and ATExecDetachPartition().
  */
-static void
+void
 RemoveInheritance(Relation child_rel, Relation parent_rel, bool expect_detached)
 {
 	Relation	catalogRelation;
